const extractor = (string, separator) => Number(string.split(separator)[0]);
const extractNumericValue = (rawValue) => {
    return rawValue.includes('.') ? extractor(rawValue, '.') : extractor(rawValue, 'px');
}
const setPxValue = value => String(value) + 'px';

const meta = document.querySelector('meta[name="geo"]');
const lang = meta ? meta.getAttribute('content').toLowerCase() : 'en';

const localTextsMap = {
    vn: 'Tôi đồng ý với việc xử lý dữ liệu cá nhân',
    id: 'Saya setuju untuk memproses data pribadi',
    my: 'Saya bersetuju untuk memproses data peribadi',
    ph: 'Sumasang-ayon ako sa pagproseso ng personal na data',
    in: 'मैं व्यक्तिगत डेटा के प्रसंस्करण के लिए सहमत हूं',
    th: 'ฉันยอมรับการประมวลผลข้อมูลส่วนบุคคล',
    en: 'I agree to the processing of personal data',
    ru: 'Я принимаю условия обработки персональных данных'
}
const localText = localTextsMap[lang] || localTextsMap.en;

const checkboxStyle = `
    all: initial;
    cursor: default;
    appearance: checkbox;
    margin: 4px!important;
`.trim();
const paragraphStyle = `
    font-size: 12px;
    padding: 4px 0!important;
    align-items: center;
    color: #ab7600;
`.trim();

const div = document.createElement('div');
div.innerHTML = `
        <p id="agreement20" style="${paragraphStyle}">
            <input type="checkbox" name="Lead[agreement]" checked style="${checkboxStyle}">
            ${localText}
        </p>
    `.trim();
const agreement = div.firstChild;

const forms = document.querySelectorAll('form');
forms.forEach(form => {
    const btnFromConstructor = form.querySelector('[id^="BUTTON"]');
    const isShittyLayout = form.firstElementChild.classList.contains('text-area');

    if (btnFromConstructor) {
        const { top: btnTop, height: btnHeight } = getComputedStyle(btnFromConstructor);

        const shift = 10;
        const btnTopNumeric = extractNumericValue(btnTop) - shift;
        const agreementTopNumeric = extractNumericValue(btnHeight) + btnTopNumeric;

        const newBtnTop = setPxValue(btnTopNumeric);
        const agreementTop = setPxValue(agreementTopNumeric);

        btnFromConstructor.style.top = newBtnTop;
        agreement.style.position = 'absolute';
        agreement.style.top = `${agreementTop}`;
        btnFromConstructor.after(agreement.cloneNode(true));

    } else if (isShittyLayout) {
        form.firstElementChild.append(agreement.cloneNode(true));

    } else {
        form.append(agreement.cloneNode(true));
    }
});